use actix_web::{http::header::ContentType, HttpResponse};
use askama::Template;

pub trait TemplateResponse {
    fn to_response(&self) -> Result<HttpResponse, askama::Error>;
}

impl<T: Template> TemplateResponse for T {
    fn to_response(&self) -> Result<HttpResponse, askama::Error> {
        let rendered_template = self.render()?;

        let response = HttpResponse::Ok()
            .content_type(ContentType::html())
            .body(rendered_template);

        Ok(response)
    }
}
